#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp		progstart
	.dw 	0
	.dw 	shelltitle

shelltitle:
	.db 	"HomeStck v.1 Install by Andy Hochhaus",0

progstart:
	ld		hl,$5a69				;[sqrt]home name in rom
	rst		20h						;"[SQRT]home" in OP1
	rst		10h						;_findsym
	call	nc,_delvar				;delete var if it exists
	ld		hl,codeend-codestart	;calc size of prog
	push	hl
	call	_createprog				;make [sqrt] prog
	ld		a,b
	ex		de,hl
	call	_ahl_plus_2_pg3
	call	_set_abs_dest_addr
	xor		a
	pop		hl
	call	_set_mm_num_bytes
	xor		a
	ld		hl,code
	call	_set_abs_src_addr
	call	_mm_ldir
	set		4,(iy+$24)			;activate [sqrt]home prog
	call	$49dc				;flushallmenus
	call	_clrScrn			;clr LCD and TextMem
	ld		a,7					;place cursor
	ld		(_curRow),a
	ret

code:
	.org	_asm_exec_ram-2

codestart:
	.db		$8e,$28				;necessary at start of sqrt progs

	ld		a,(_winBtm)
	dec		a
	ld		b,a

	ld		a,(_curRow)
	cp		b					;if	(_curRow)<(_winBtm) goto movedown

	call	c,movedown

	ld		a,b
	ld		(_curRow),a
	ld		a,(_asm_reg_a)
	ld		bc,(_asm_reg_bc)

end:
	cp		a
	ret

movedown:
	ld		a,(_curRow)
	cp		6
	jp		nz,onemenustillup	;if one menu is still active don't refresh screen based on text mem

	ld		a,(_curCol)
	push	af

	call	$4ac3				;rstrShadow NOTE:DESTROYS (_curCol) and makes screen flicker

	pop		af
	ld		(_curCol),a			;restores (_curCol)

onemenustillup:
	call	$4a7a				;_scrollDown

	ld		a,(_winBtm)
	dec		a
	ld		b,a
	ret

codeend:

.end
